//+------------------------------------------------------------------+
//|                                                   nomoreloss.mq4 |
//|                                                kniterr@gmail.com |
//+------------------------------------------------------------------+

extern string comment1="                 Entry Settings";
extern bool   intraday         = true;
extern int    trendTF          = PERIOD_D1; //
extern int    signalTF         = PERIOD_H1;   //in minutes
extern double prevRange        = 0.0030; 
extern string comment2="                 Trading time";
extern int    start            = 6;
extern int    end              = 24; //0 and 24 for 24h/5days a week
extern string comment3="                 Position Management";
extern bool   MM               = true;
extern int    RiskPerTrade     = 3; // in%
extern double Lots             = 1; // important only in case of MM=false
int    orders           = 1;
extern string comment4="                 Order Management";
extern int    TakeProfit       = 100;
extern int    StopLoss         = 200;
extern int    TrailingStop     = 0;
extern int    TrailingStopStep = 0;
extern int    BE               = 100;
extern int    Slippage         = 10;
extern string comment5="                 Magic :)";
extern int    Magic            = 250879;
string comment ="nomoreloss";
double YOpen, YClose, YHigh, YLow, TOpen, TClose;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   
   int cnt, ticket, total;
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
 
// variables
  YHigh  = iHigh(NULL, trendTF, 0);
  YOpen  = iOpen(NULL, trendTF, 0);
  YClose = iClose(NULL, trendTF, 0);
  YLow   = iLow(NULL, trendTF, 0);
  TOpen  = iOpen(NULL, signalTF, 0);
  TClose  = iClose(NULL, signalTF, 0);
   
  double SL, TP;

//   GetEven();
   SL = 0;
   TP = 0;
   total=OrdersTotal();
   if(total<orders) 
     {
      // tylko jedno zlecenie na raz
      Lots = GetLots();
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  // sprawdzenie zabezpieczenia
        }
      // wyszukanie sygnalu
      GetSignal();
      // BUY
      if(GetSignal() == 1)
        {
         if (StopLoss >0) SL=Ask-StopLoss*Point; else SL=0;
         if (TakeProfit >0) TP = Ask+(MarketInfo(Symbol(),MODE_SPREAD)+TakeProfit)*Point; else TP=0;
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,comment,Magic,0,Green);
         if(ticket>0)
           { 
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // SELL
      if(GetSignal() == -1)
        {
         if (StopLoss >0) SL = Bid+StopLoss*Point; else SL=0;
         if (TakeProfit >0) TP = Bid-(MarketInfo(Symbol(),MODE_SPREAD)+TakeProfit)*Point; else TP=0;
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,comment,Magic,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // close conditions for Long
           if(Hour()>end) //||TOpen>TClose)
                  {
                 OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*(TrailingStop+TrailingStopStep))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // close condition Short
            if(Hour()>end)//||TOpen<TClose)
  
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*(TrailingStop+TrailingStopStep))) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
double GetSignal()
   {  double range, strength, level; int ssp1;
      string ssp,text;
      strength = 0;   
     if (Hour()>=start && Hour()<=end) 
     { range = YHigh-YLow; 
       if (range>prevRange) strength=1;
        {
        //--- levels
         ssp1= Bid / Point;
         text=DoubleToStr(Bid / Point,6);
         ssp=StringSubstr(text,3,2);
         if ( ssp=="00"||ssp=="50"||ssp=="25"||ssp=="75") level=1; else level=0;
         
         
         double signal = 0;
         if (strength==1 && YOpen<Ask && TOpen<Ask && level==1 && signal != 1) signal = 1; //long
         if (strength==1 && YOpen>Ask && TOpen>Ask && level==1 && signal !=-1) signal = -1; //short
         return(signal);
        }
     }
    else return(0);     
   }  
  
double GetLots()
   {
   double Lot;
   Lot = 1. * NormalizeDouble(MathSqrt(AccountEquity()*RiskPerTrade/100/1000),1);// Calculate the amount of lots  
      double Min_Lot = MarketInfo(Symbol(), MODE_MINLOT);   // Minimum allowed lot value
   if (MM == false) Lot=Lots;
      if (Lot == 0 ) Lot = Min_Lot;
   return(Lot);
   }  
   
int deinit()
  {
   // ObjectsDeleteAll();
   return(0);
  }
// the end.